git-commit: make sure we protect against races.
[git.git] / git-commit.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
5
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>) [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
7 SUBDIRECTORY_OK=Yes
8 . git-sh-setup
9
10 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
11 branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)
12
13 case "$0" in
14 *status)
15         status_only=t
16         unmerged_ok_if_status=--unmerged ;;
17 *commit)
18         status_only=
19         unmerged_ok_if_status= ;;
20 esac
21
22 refuse_partial () {
23         echo >&2 "$1"
24         echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
25         exit 1
26 }
27
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
30 rm -f "$NEXT_INDEX"
31 save_index () {
32         cp "$THIS_INDEX" "$NEXT_INDEX"
33 }
34
35 report () {
36   header="#
37 # $1:
38 #   ($2)
39 #
40 "
41   trailer=""
42   while read status name newname
43   do
44     printf '%s' "$header"
45     header=""
46     trailer="#
47 "
48     case "$status" in
49     M ) echo "# modified: $name";;
50     D*) echo "# deleted:  $name";;
51     T ) echo "# typechange: $name";;
52     C*) echo "# copied: $name -> $newname";;
53     R*) echo "# renamed: $name -> $newname";;
54     A*) echo "# new file: $name";;
55     U ) echo "# unmerged: $name";;
56     esac
57   done
58   printf '%s' "$trailer"
59   [ "$header" ]
60 }
61
62 run_status () {
63     (
64         # We always show status for the whole tree.
65         cd "$TOP"
66
67         IS_INITIAL="$initial_commit"
68         REFERENCE=HEAD
69         case "$amend" in
70         t)
71                 # If we are amending the initial commit, there
72                 # is no HEAD^1.
73                 if git-rev-parse --verify "HEAD^1" >/dev/null 2>&1
74                 then
75                         REFERENCE="HEAD^1"
76                         IS_INITIAL=
77                 else
78                         IS_INITIAL=t
79                 fi
80                 ;;
81         esac
82
83         # If TMP_INDEX is defined, that means we are doing
84         # "--only" partial commit, and that index file is used
85         # to build the tree for the commit.  Otherwise, if
86         # NEXT_INDEX exists, that is the index file used to
87         # make the commit.  Otherwise we are using as-is commit
88         # so the regular index file is what we use to compare.
89         if test '' != "$TMP_INDEX"
90         then
91             GIT_INDEX_FILE="$TMP_INDEX"
92             export GIT_INDEX_FILE
93         elif test -f "$NEXT_INDEX"
94         then
95             GIT_INDEX_FILE="$NEXT_INDEX"
96             export GIT_INDEX_FILE
97         fi
98
99         case "$branch" in
100         refs/heads/master) ;;
101         *)  echo "# On branch $branch" ;;
102         esac
103
104         if test -z "$IS_INITIAL"
105         then
106             git-diff-index -M --cached --name-status \
107                 --diff-filter=MDTCRA $REFERENCE |
108             sed -e '
109                     s/\\/\\\\/g
110                     s/ /\\ /g
111             ' |
112             report "Updated but not checked in" "will commit"
113             committable="$?"
114         else
115             echo '#
116 # Initial commit
117 #'
118             git-ls-files |
119             sed -e '
120                     s/\\/\\\\/g
121                     s/ /\\ /g
122                     s/^/A /
123             ' |
124             report "Updated but not checked in" "will commit"
125
126             committable="$?"
127         fi
128
129         git-diff-files  --name-status |
130         sed -e '
131                 s/\\/\\\\/g
132                 s/ /\\ /g
133         ' |
134         report "Changed but not updated" \
135             "use git-update-index to mark for commit"
136
137         if test -f "$GIT_DIR/info/exclude"
138         then
139             git-ls-files -z --others --directory \
140                 --exclude-from="$GIT_DIR/info/exclude" \
141                 --exclude-per-directory=.gitignore
142         else
143             git-ls-files -z --others --directory \
144                 --exclude-per-directory=.gitignore
145         fi |
146         perl -e '$/ = "\0";
147             my $shown = 0;
148             while (<>) {
149                 chomp;
150                 s|\\|\\\\|g;
151                 s|\t|\\t|g;
152                 s|\n|\\n|g;
153                 s/^/#   /;
154                 if (!$shown) {
155                     print "#\n# Untracked files:\n";
156                     print "#   (use \"git add\" to add to commit)\n";
157                     print "#\n";
158                     $shown = 1;
159                 }
160                 print "$_\n";
161             }
162         '
163
164         if test -n "$verbose"
165         then
166             git-diff-index --cached -M -p --diff-filter=MDTCRA $REFERENCE
167         fi
168         case "$committable" in
169         0)
170             echo "nothing to commit"
171             exit 1
172         esac
173         exit 0
174     )
175 }
176
177 trap '
178         test -z "$TMP_INDEX" || {
179                 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
180         }
181         rm -f "$NEXT_INDEX"
182 ' 0
183
184 ################################################################
185 # Command line argument parsing and sanity checking
186
187 all=
188 also=
189 only=
190 logfile=
191 use_commit=
192 amend=
193 no_edit=
194 log_given=
195 log_message=
196 verify=t
197 verbose=
198 signoff=
199 force_author=
200 only_include_assumed=
201 while case "$#" in 0) break;; esac
202 do
203   case "$1" in
204   -F|--F|-f|--f|--fi|--fil|--file)
205       case "$#" in 1) usage ;; esac
206       shift
207       no_edit=t
208       log_given=t$log_given
209       logfile="$1"
210       shift
211       ;;
212   -F*|-f*)
213       no_edit=t
214       log_given=t$log_given
215       logfile=`expr "$1" : '-[Ff]\(.*\)'`
216       shift
217       ;;
218   --F=*|--f=*|--fi=*|--fil=*|--file=*)
219       no_edit=t
220       log_given=t$log_given
221       logfile=`expr "$1" : '-[^=]*=\(.*\)'`
222       shift
223       ;;
224   -a|--a|--al|--all)
225       all=t
226       shift
227       ;;
228   --au=*|--aut=*|--auth=*|--autho=*|--author=*)
229       force_author=`expr "$1" : '-[^=]*=\(.*\)'`
230       shift
231       ;;
232   --au|--aut|--auth|--autho|--author)
233       case "$#" in 1) usage ;; esac
234       shift
235       force_author="$1"
236       shift
237       ;;
238   -e|--e|--ed|--edi|--edit)
239       no_edit=
240       shift
241       ;;
242   -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
243       also=t
244       shift
245       ;;
246   -o|--o|--on|--onl|--only)
247       only=t
248       shift
249       ;;
250   -m|--m|--me|--mes|--mess|--messa|--messag|--message)
251       case "$#" in 1) usage ;; esac
252       shift
253       log_given=t$log_given
254       log_message="$1"
255       no_edit=t
256       shift
257       ;;
258   -m*)
259       log_given=t$log_given
260       log_message=`expr "$1" : '-m\(.*\)'`
261       no_edit=t
262       shift
263       ;;
264   --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
265       log_given=t$log_given
266       log_message=`expr "$1" : '-[^=]*=\(.*\)'`
267       no_edit=t
268       shift
269       ;;
270   -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
271       verify=
272       shift
273       ;;
274   --a|--am|--ame|--amen|--amend)
275       amend=t
276       log_given=t$log_given
277       use_commit=HEAD
278       shift
279       ;;
280   -c)
281       case "$#" in 1) usage ;; esac
282       shift
283       log_given=t$log_given
284       use_commit="$1"
285       no_edit=
286       shift
287       ;;
288   --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
289   --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
290   --reedit-messag=*|--reedit-message=*)
291       log_given=t$log_given
292       use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
293       no_edit=
294       shift
295       ;;
296   --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
297   --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
298       case "$#" in 1) usage ;; esac
299       shift
300       log_given=t$log_given
301       use_commit="$1"
302       no_edit=
303       shift
304       ;;
305   -C)
306       case "$#" in 1) usage ;; esac
307       shift
308       log_given=t$log_given
309       use_commit="$1"
310       no_edit=t
311       shift
312       ;;
313   --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
314   --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
315   --reuse-message=*)
316       log_given=t$log_given
317       use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
318       no_edit=t
319       shift
320       ;;
321   --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
322   --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
323       case "$#" in 1) usage ;; esac
324       shift
325       log_given=t$log_given
326       use_commit="$1"
327       no_edit=t
328       shift
329       ;;
330   -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
331       signoff=t
332       shift
333       ;;
334   -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
335       verbose=t
336       shift
337       ;;
338   --)
339       shift
340       break
341       ;;
342   -*)
343       usage
344       ;;
345   *)
346       break
347       ;;
348   esac
349 done
350
351 ################################################################
352 # Sanity check options
353
354 case "$amend,$initial_commit" in
355 t,t)
356   die "You do not have anything to amend." ;;
357 t,)
358   if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
359     die "You are in the middle of a merge -- cannot amend."
360   fi ;;
361 esac
362
363 case "$log_given" in
364 tt*)
365   die "Only one of -c/-C/-F/-m can be used." ;;
366 esac
367
368 case "$#,$also$only" in
369 *,tt)
370   die "Only one of --include/--only can be used." ;;
371 0,t)
372   die "No paths with --include/--only does not make sense." ;;
373 0,)
374   ;;
375 *,)
376   only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
377   also=
378   ;;
379 esac
380 unset only
381 case "$all,$also,$#" in
382 t,t,*)
383         die "Cannot use -a and -i at the same time." ;;
384 t,,[1-9]*)
385         die "Paths with -a does not make sense." ;;
386 ,t,0)
387         die "No paths with -i does not make sense." ;;
388 esac
389
390 ################################################################
391 # Prepare index to have a tree to be committed
392
393 TOP=`git-rev-parse --show-cdup`
394 if test -z "$TOP"
395 then
396         TOP=./
397 fi
398
399 case "$all,$also" in
400 t,)
401         save_index &&
402         (
403                 cd "$TOP"
404                 GIT_INDEX_FILE="$NEXT_INDEX"
405                 export GIT_INDEX_FILE
406                 git-diff-files --name-only -z |
407                 git-update-index --remove -z --stdin
408         )
409         ;;
410 ,t)
411         save_index &&
412         git-ls-files --error-unmatch -- "$@" >/dev/null || exit
413
414         git-diff-files --name-only -z -- "$@"  |
415         (
416                 cd "$TOP"
417                 GIT_INDEX_FILE="$NEXT_INDEX"
418                 export GIT_INDEX_FILE
419                 git-update-index --remove -z --stdin
420         )
421         ;;
422 ,)
423         case "$#" in
424         0)
425             ;; # commit as-is
426         *)
427             if test -f "$GIT_DIR/MERGE_HEAD"
428             then
429                 refuse_partial "Cannot do a partial commit during a merge."
430             fi
431             TMP_INDEX="$GIT_DIR/tmp-index$$"
432             if test -z "$initial_commit"
433             then
434                 # make sure index is clean at the specified paths, or
435                 # they are additions.
436                 dirty_in_index=`git-diff-index --cached --name-status \
437                         --diff-filter=DMTU HEAD -- "$@"`
438                 test -z "$dirty_in_index" ||
439                 refuse_partial "Different in index and the last commit:
440 $dirty_in_index"
441             fi
442             commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
443
444             # Build the temporary index and update the real index
445             # the same way.
446             if test -z "$initial_commit"
447             then
448                 cp "$THIS_INDEX" "$TMP_INDEX"
449                 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
450             else
451                     rm -f "$TMP_INDEX"
452             fi || exit
453
454             echo "$commit_only" |
455             GIT_INDEX_FILE="$TMP_INDEX" \
456             git-update-index --add --remove --stdin &&
457
458             save_index &&
459             echo "$commit_only" |
460             (
461                 GIT_INDEX_FILE="$NEXT_INDEX"
462                 export GIT_INDEX_FILE
463                 git-update-index --remove --stdin
464             ) || exit
465             ;;
466         esac
467         ;;
468 esac
469
470 ################################################################
471 # If we do as-is commit, the index file will be THIS_INDEX,
472 # otherwise NEXT_INDEX after we make this commit.  We leave
473 # the index as is if we abort.
474
475 if test -f "$NEXT_INDEX"
476 then
477         USE_INDEX="$NEXT_INDEX"
478 else
479         USE_INDEX="$THIS_INDEX"
480 fi
481
482 GIT_INDEX_FILE="$USE_INDEX" \
483     git-update-index -q $unmerged_ok_if_status --refresh || exit
484
485 ################################################################
486 # If the request is status, just show it and exit.
487
488 case "$0" in
489 *status)
490         run_status
491         exit $?
492 esac
493
494 ################################################################
495 # Grab commit message, write out tree and make commit.
496
497 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
498 then
499         if test "$TMP_INDEX"
500         then
501                 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
502         else
503                 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
504         fi || exit
505 fi
506
507 if test "$log_message" != ''
508 then
509         echo "$log_message"
510 elif test "$logfile" != ""
511 then
512         if test "$logfile" = -
513         then
514                 test -t 0 &&
515                 echo >&2 "(reading log message from standard input)"
516                 cat
517         else
518                 cat <"$logfile"
519         fi
520 elif test "$use_commit" != ""
521 then
522         git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
523 elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
524 then
525         cat "$GIT_DIR/MERGE_MSG"
526 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
527
528 case "$signoff" in
529 t)
530         {
531                 echo
532                 git-var GIT_COMMITTER_IDENT | sed -e '
533                         s/>.*/>/
534                         s/^/Signed-off-by: /
535                 '
536         } >>"$GIT_DIR"/COMMIT_EDITMSG
537         ;;
538 esac
539
540 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
541         echo "#"
542         echo "# It looks like you may be committing a MERGE."
543         echo "# If this is not correct, please remove the file"
544         echo "# $GIT_DIR/MERGE_HEAD"
545         echo "# and try again"
546         echo "#"
547 fi >>"$GIT_DIR"/COMMIT_EDITMSG
548
549 # Author
550 if test '' != "$force_author"
551 then
552         GIT_AUTHOR_NAME=`expr "$force_author" : '\(.*[^ ]\) *<.*'` &&
553         GIT_AUTHOR_EMAIL=`expr "$force_author" : '.*\(<.*\)'` &&
554         test '' != "$GIT_AUTHOR_NAME" &&
555         test '' != "$GIT_AUTHOR_EMAIL" ||
556         die "malformatted --author parameter"
557         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
558 elif test '' != "$use_commit"
559 then
560         pick_author_script='
561         /^author /{
562                 s/'\''/'\''\\'\'\''/g
563                 h
564                 s/^author \([^<]*\) <[^>]*> .*$/\1/
565                 s/'\''/'\''\'\'\''/g
566                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
567
568                 g
569                 s/^author [^<]* <\([^>]*\)> .*$/\1/
570                 s/'\''/'\''\'\'\''/g
571                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
572
573                 g
574                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
575                 s/'\''/'\''\'\'\''/g
576                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
577
578                 q
579         }
580         '
581         set_author_env=`git-cat-file commit "$use_commit" |
582         LANG=C LC_ALL=C sed -ne "$pick_author_script"`
583         eval "$set_author_env"
584         export GIT_AUTHOR_NAME
585         export GIT_AUTHOR_EMAIL
586         export GIT_AUTHOR_DATE
587 fi
588
589 PARENTS="-p HEAD"
590 if test -z "$initial_commit"
591 then
592         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
593                 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
594         elif test -n "$amend"; then
595                 PARENTS=$(git-cat-file commit HEAD |
596                         sed -n -e '/^$/q' -e 's/^parent /-p /p')
597         fi
598         current=$(git-rev-parse --verify HEAD)
599 else
600         if [ -z "$(git-ls-files)" ]; then
601                 echo >&2 Nothing to commit
602                 exit 1
603         fi
604         PARENTS=""
605         current=
606 fi
607
608 {
609         test -z "$only_include_assumed" || echo "$only_include_assumed"
610         run_status
611 } >>"$GIT_DIR"/COMMIT_EDITMSG
612 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" ]
613 then
614         rm -f "$GIT_DIR/COMMIT_EDITMSG"
615         run_status
616         exit 1
617 fi
618 case "$no_edit" in
619 '')
620         case "${VISUAL:-$EDITOR},$TERM" in
621         ,dumb)
622                 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
623                 echo >&2 "Please supply the commit log message using either"
624                 echo >&2 "-m or -F option.  A boilerplate log message has"
625                 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
626                 exit 1
627                 ;;
628         esac
629         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
630         ;;
631 esac
632
633 case "$verify" in
634 t)
635         if test -x "$GIT_DIR"/hooks/commit-msg
636         then
637                 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
638         fi
639 esac
640
641 sed -e '
642     /^diff --git a\/.*/{
643         s///
644         q
645     }
646     /^#/d
647 ' "$GIT_DIR"/COMMIT_EDITMSG |
648 git-stripspace >"$GIT_DIR"/COMMIT_MSG
649
650 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
651         git-stripspace |
652         wc -l` &&
653    test 0 -lt $cnt
654 then
655         if test -z "$TMP_INDEX"
656         then
657                 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
658         else
659                 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
660                 rm -f "$TMP_INDEX"
661         fi &&
662         commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
663         git-update-ref HEAD $commit $current &&
664         rm -f -- "$GIT_DIR/MERGE_HEAD" &&
665         if test -f "$NEXT_INDEX"
666         then
667                 mv "$NEXT_INDEX" "$THIS_INDEX"
668         else
669                 : ;# happy
670         fi
671 else
672         echo >&2 "* no commit message?  aborting commit."
673         false
674 fi
675 ret="$?"
676 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG"
677 if test -d "$GIT_DIR/rr-cache"
678 then
679         git-rerere
680 fi
681
682 if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
683 then
684         "$GIT_DIR"/hooks/post-commit
685 fi
686 exit "$ret"